if ( extLoadLock == undefined ) {
var extLoadLock = 1;

var extensionSettings = {};
var extensionFlags = {};
var loadingPage = false;
var tabIndex;

/*
 * Navigation Bar
*/

var dataPage = false;

var navBar = null;
var navBarLeft = null;
var navBarRight = null;
var navBarCenter = null;
var searchBar = null;
var stopButton = null;
var wifiPlaceholder = null;

var isNavBarActive = false;

var navBarBookmark = null;
var navBarBookmarkList = null;
var bookmarkText = null;
var bookmarkList = null;

var reloadBtn = null;
var bookmarksBtn = null;
var addBookmarkBtn = null;
var optionsBtn = null;
var closeBtn = null;
var backBtn = null;
var forwardBtn = null;

var urlExpr = /(https?:\/\/(?:www\.|(?!www))[^\s\.]+\.[^\s]{2,}|www\.[^\s]+\.[^\s]{2,})|[^\s\.]+\.[^\s]{2,}|[^\s]+\.[^\s]{2,}/i
var urlRegex = new RegExp(urlExpr);

chrome.runtime.onMessage.addListener(function(msg, sender, sendResponse) {
   if ( msg.tree )
      updateBookmarkList(msg.tree);

   if ( msg.settings ) {
      extensionSettings = msg.settings;

      if (navBar && ( !msg.settings.enableNavBar || ( extensionSettings.autoNavBar && !location.href.startsWith("chrome-error://") ) ) ) {
         document.documentElement.removeChild(navBar);
         navBar = null;
      } else if (msg.settings.enableNavBar )
         initAddressBar(true);
   }

   if( msg.error && !navBar )
      initAddressBar(true);

   if ( msg.closeNavBar ) {
      eventCloseNavBar(false);
   }

   return true;
});

function eventCloseNavBar(e) {
   if ( !e || ( isNavBarActive && !( e.target == navBar || navBar.contains(e.target) )) ) {
      resetNavBar();
      if ( ! extensionFlags.fixedToolbar ) {
         isNavBarActive = false;
         navBar.setAttribute("class", "ext_navBarUp");
         chrome.runtime.sendMessage("", { cmd: "resumeReload"});
      }
   }
}

document.addEventListener("click", eventCloseNavBar);

function setHistoryButtons() {
    chrome.runtime.sendMessage("", { cmd: "getBackCount"}, function(backCount) {
       backCount = backCount.backCount;
       if (window.history.length > (backCount + 1)) {
          backBtn.onclick = function(){
              backBtn.setAttribute('class', 'ext_navBarButton ext_buttonActive');
              chrome.runtime.sendMessage("", { cmd: "goingBack" });
              window.history.back();
              window.setTimeout(function() { backBtn.setAttribute('class', 'ext_navBarButton'); setHistoryButtons(); }, 1000);
          }
       } else {
          backBtn.onclick = null;
          backBtn.setAttribute('class', 'ext_navBarButton ext_buttonDisabled');
       }

       if (backCount != 0) {
          forwardBtn.onclick = function(){
             forwardBtn.setAttribute('class', 'ext_navBarButton ext_buttonActive');
             window.history.forward();
             window.setTimeout(function() { forwardBtn.setAttribute('class', 'ext_navBarButton'); setHistoryButtons(); }, 1000);
          }
       } else {
          forwardBtn.onclick = null;
          forwardBtn.setAttribute('class', 'ext_navBarButton ext_buttonDisabled');
       }
    });
}

function updateBookmarkList(bookmarkTree) {

   if ( !bookmarkTree || !navBarBookmark )
      return;

   if( bookmarkList )
      navBarBookmarkList.removeChild(bookmarkList);

   bookmarkList = document.createElement('ul');
   bookmarkList.setAttribute('id', 'ext_bookmarkList');

   var listEntry;
   var listDeleteBtn;
   var listLink;
   var title;

   bookmarkTree.forEach(function(bookmark) {
      if ( ! bookmark.url )
         return;

      if ( !bookmark.title || bookmark.title == "" )
         title = "Unnamed";
      else
         title = bookmark.title;
      
      listEntry = document.createElement('li');

      listLink = document.createElement('a');
      listLink.setAttribute('class', 'ext_listElement');      
      listLink.setAttribute('data-url', bookmark.url );
      listLink.onclick = loadBookmark;
      listLink.innerHTML = title;

      listDeleteBtn = document.createElement('div');
      listDeleteBtn.setAttribute('class', 'ext_listDeleteBtn');
      listDeleteBtn.onclick = deleteBookmark;
      listDeleteBtn.setAttribute('data-id', bookmark.id );
      listEntry.appendChild(listLink);
      listEntry.appendChild(listDeleteBtn);
      bookmarkList.appendChild(listEntry);
   });

   navBarBookmarkList.appendChild(bookmarkList);

}

function deleteBookmark(e) {
   chrome.runtime.sendMessage("", { cmd: "removeBookmark", id: this.getAttribute('data-id')});
   if (dataPage)
      window.location.reload();
   e.stopPropagation();
}

function loadBookmark(e) {
   var url = this.getAttribute('data-url');
   window.location.href = url;
   toggleBookmarkList();
   if(searchBar)
      searchBar.setAttribute('value', url);
}

function addNavBarButton(id, parent) {
   var button = document.createElement('div');
   button.setAttribute('id', id);
   button.setAttribute('class', 'ext_navBarButton');
   parent.appendChild(button);
   return button;
}

function showWiFiStatus(parent) {
   var xmlHttp = new XMLHttpRequest();
   xmlHttp.open("GET", "http://127.0.0.1:3000/api/v1/");
   xmlHttp.onreadystatechange = function() {
      var status;
      var data;
      if (xmlHttp.readyState == 4) {
         status = xmlHttp.status;
         if (status == 200) {
            data = JSON.parse(xmlHttp.responseText);
            var wifistate = data["system"]["volatile"]["services"]["wifi"]["interfaces"]["wifi0"]["state"];
            var signal = data["system"]["volatile"]["services"]["wifi"]["interfaces"]["wifi0"]["signalLevel"];
            var interfaces = data["network"]["interfaces"];
            var ethstate = false;
            for (var i = 0; i < interfaces.length; i++) {
               if (interfaces[i]["name"] == "eth0") {
                  if (typeof(interfaces[i]["actual_gateway_ip"]) != "undefined")
                  {
                     ethstate = true;
                  }
                  break;
               }
            }
            if (!ethstate) {
               button = "ext_wifiNC";
               if (wifistate == 10) {
                  if (signal < -70) {
                     button = "ext_wifiBad";
                  } else if (signal < -50) {
                     button = "ext_wifiMedium";
                  } else {
                     button = "ext_wifiGood";
                  }
               }
               parent.innerHTML = "";
               addNavBarButton(button, parent);
            } else {
               parent.innerHTML = "";
            }
         }
      }
   };
   xmlHttp.send();
}

function removeKeyEventHandlers(element) {
   element.onkeydown = function(e) {
      e.stopPropagation();
   }
   element.onkeypress = function(e) {
      e.stopPropagation();
   }
}

function initAddressBar(fromBackend){

// Create main div
   if (location.href.startsWith("chrome-extension://") || !extensionSettings.enableNavBar)
      return;

   if (extensionSettings.autoNavBar && !location.href.startsWith("chrome-error://") && !fromBackend )
      return;

   navBar = document.getElementById('ext_navBarMain');
   if (navBar != null)
   {
       navBar.parentNode.removeChild(navBar);
   }

   navBar = document.createElement('div');
   navBar.setAttribute('id', 'ext_navBarMain');
   navBar.setAttribute('class', 'ext_navBarUp');

   navBarLeft = document.createElement('div');
   navBarLeft.setAttribute('id', 'ext_navBarLeft');

   if ( extensionFlags.toolbarReload == null || extensionFlags.toolbarReload ) {
      reloadBtn = addNavBarButton('ext_reloadButton', navBarLeft);
      reloadBtn.onclick = function(){
         reloadBtn.setAttribute('class', 'ext_navBarButton ext_buttonActive');
         chrome.runtime.sendMessage("", { cmd: "loadPage" });
      }
   }

   if ( extensionSettings.loadingBar ) {
      stopButton = addNavBarButton('ext_stopButton', navBarLeft);
      stopButton.onclick = function(){
         stopButton.setAttribute('class', 'ext_navBarButton ext_buttonActive');
         window.stop();
      }
      reloadBtn.style="display:none";
      stopButton.style="display:inline-block";
   }

   if (  extensionFlags.toolbarBookmarks ) {
      // Add create new bookmark div
      navBarBookmark = document.createElement('div');
      navBarBookmark.setAttribute('id', 'ext_navBarBookmark');
      navBarBookmark.style.display = "none";
      navBar.appendChild(navBarBookmark);

      var bookmarkForm = document.createElement('form');

      var bookmarkTextLabel = document.createElement('label');
      bookmarkTextLabel.setAttribute('class', 'ext_font');
      bookmarkTextLabel.innerHTML = "Name:";

      var bookmarkText = document.createElement('input');
      bookmarkText.setAttribute('type', 'text');
      bookmarkText.setAttribute('id', 'ext_bookmarkName');
      bookmarkText.setAttribute('value', document.title);
      removeKeyEventHandlers(bookmarkText);

      var bookmarkAdd = document.createElement('input');
      bookmarkAdd.setAttribute('type', 'submit');
      bookmarkAdd.setAttribute('id', 'ext_bookmarkAdd');
      bookmarkAdd.setAttribute('value', 'Add Bookmark');

      bookmarkForm.appendChild(bookmarkTextLabel);
      bookmarkForm.appendChild(bookmarkText);
      bookmarkForm.appendChild(bookmarkAdd);
      bookmarkForm.onsubmit = function(e) {
         e.preventDefault();
         chrome.runtime.sendMessage("", { cmd: "addBookmark", title: bookmarkText.value });
         toggleBookmarkAdd();
         if (dataPage)
            window.location.reload();
      }

      navBarBookmark.appendChild(bookmarkForm);


      // Bookmark list div

      navBarBookmarkList = document.createElement('div');
      navBarBookmarkList.setAttribute('id', 'ext_navBarBookmarkList');
      navBarBookmarkList.style.display = "none";

      bookmarksBtn = addNavBarButton('ext_bookmarksButton', navBarLeft);
      bookmarksBtn.onclick = function(event){
        if (this != event.target)
            return;
         toggleBookmarkList();
      }
      bookmarksBtn.appendChild(navBarBookmarkList);
   }

// Tag div

   if ( ! extensionFlags.fixedToolbar ) {
      var navBarTag = document.createElement('div');
      navBarTag.setAttribute('id', 'ext_navBarTag');
      var navBarTagInner = document.createElement('div');
      navBarTagInner.setAttribute('id', 'ext_navBarTagInner');
      navBarTag.onmousedown = function(){
         isNavBarActive = true;
         navBar.setAttribute("class", "ext_navBarDown");
         chrome.runtime.sendMessage("", { cmd: "pauseReload"});
         if ( !bookmarkList )
            chrome.runtime.sendMessage("", { cmd: "getBookmarkTree" }, function(tree){
               if ( tree )
                  updateBookmarkList(tree);
            });
      }

      navBarTag.appendChild(navBarTagInner);
      navBar.appendChild(navBarTag);
   } else {
         isNavBarActive = true;
         navBar.setAttribute("class", "ext_navBarDown");
         if ( !bookmarkList )
            chrome.runtime.sendMessage("", { cmd: "getBookmarkTree" }, function(tree){
               if ( tree )
                  updateBookmarkList(tree);
            });
   }

// Create main div left side and its buttons
   chrome.runtime.sendMessage("", { cmd: "openingPage", hlen: window.history.length });

   if ( extensionSettings.historyBtns ) {
      backBtn = addNavBarButton('ext_backButton', navBarLeft);
      forwardBtn = addNavBarButton('ext_forwardButton', navBarLeft);
      setHistoryButtons();
   }

// Create main div center with url form and addBookmark button

   navBarCenter = document.createElement('div');
   navBarCenter.setAttribute('id', 'ext_navBarCenter');

   if ( extensionFlags.toolbarUrl == null || extensionFlags.toolbarUrl ) {
      var urlForm = document.createElement('form');

      searchBar = document.createElement('input');
      searchBar.setAttribute('id', 'ext_search');
      searchBar.setAttribute('type', 'text');
      if ( ! ( tabIndex == 0 && loadingPage ) )
         searchBar.setAttribute('value', window.location.href.substr(0,300));
      searchBar.onfocus = function() {
         this.select();
         resetNavBar;
      }

      removeKeyEventHandlers(searchBar);

      urlForm.appendChild(searchBar);
      urlForm.onsubmit = function(e) {
         e.preventDefault();
         var url = searchBar.value;
         if (url.match(urlRegex)) {
            if ( url.indexOf("://") == -1 )
               url = "http://" + url;
            chrome.runtime.sendMessage("", { cmd: "loadPage", url: url });
         } else {
            chrome.runtime.sendMessage("", { cmd: "loadPage", url: "https://www.google.com/search?q=" + url });
         }
      }

      navBarCenter.appendChild(urlForm);

      if ( extensionFlags.toolbarBookmarks ) {
         addBookmarkBtn = addNavBarButton('ext_addBookmarkButton', navBarCenter);
         addBookmarkBtn.onclick = function() {
            toggleBookmarkAdd();
         }
      }
   }

   // Create main div right side for options button

   navBarRight = document.createElement('div');
   navBarRight.setAttribute('id', 'ext_navBarRight');

   wifiPlaceholder = document.createElement('div');
   navBarRight.appendChild(wifiPlaceholder);

   if ( extensionFlags.toolbarOptions == null || extensionFlags.toolbarOptions ) {
      optionsBtn = addNavBarButton('ext_optionsButton', navBarRight);
      optionsBtn.onclick = function(){
         chrome.runtime.sendMessage("", { cmd: "openOptions" });
      }
   }

   if ( extensionFlags.enableExitButton ) {
      closeBtn = addNavBarButton('ext_closeButton', navBarRight);
      closeBtn.onclick = function() {
         chrome.runtime.sendMessage("", { cmd: "exitChrome" });
      }
   }

   navBar.appendChild(navBarLeft);
   navBar.appendChild(navBarCenter);
   navBar.appendChild(navBarRight);

   document.documentElement.appendChild(navBar);

   // Resize address bar
   if ( extensionFlags.toolbarUrl == null || extensionFlags.toolbarUrl ) {
      addressBarSize = navBarLeft.offsetWidth + navBarRight.offsetWidth + 125;
      navBarCenter.setAttribute("style", "width: calc(100% - " + addressBarSize + "px); left: 50%;");
   } else {
      navBarSize = navBarLeft.offsetWidth + navBarCenter.offsetWidth + navBarRight.offsetWidth +20;
      if ( extensionFlags.fixedToolbar ) {
         navBar.setAttribute("style", "width: " + navBarSize + "px; border-radius: 0px 0px 0px 5px; \
            left: calc( 100% - " + navBarSize + "px );");
         if( navBarBookmarkList )
           navBarBookmarkList.setAttribute("style", "display: none; left: 100%; transform: translateX(-100%);");
      } else {
         navBar.setAttribute("style", "width: " + navBarSize + "px; min-width: 100px; border-radius: 0px 0px 5px 5px; \
            left: calc( 50% - " + navBarSize/2 + "px );");
      }
   }

   navBarLower = document.createElement('div');
   navBarLower.setAttribute('id', 'ext_navBarLower');
   navBarLower.setAttribute("style", "display: block; margin-top:39px; width: 100%; height: 3px;");
   navBar.appendChild(navBarLower);

   if ( extensionSettings.loadingBar ) {
      isNavBarActive = true;
      //navBar.setAttribute("class", "ext_navBarDown");
      window.paceOptions = { target: "#ext_navBarLower" , reloadBtn: reloadBtn, stopButton: stopButton};
      showLoadingBar.call(this);
   }

   if ( extensionSettings.wifiStatus ) {
      showWiFiStatus(wifiPlaceholder);
      setInterval(function(){ showWiFiStatus(wifiPlaceholder); }, 5000);
   }
}

if (document.location.href.startsWith("data:text"))
   dataPage = true;

// Get Settings
chrome.runtime.sendMessage("", { cmd: "getInfo" }, function(info) {
   if ( info ) {
      if ( info.settings )
         extensionSettings = info.settings;
      if ( info.flags )
         extensionFlags = info.flags;
      loadingPage = info.loadingPage;
      tabIndex = info.tabIndex;
   }


   // Load the address bar only on first tab
   if ( info && info.tabIndex == 0 && extensionSettings.enableNavBar )
       initAddressBar();
});

function resetNavBar() {
   if ( navBarBookmark ) {
      navBarBookmark.style.display = "none";
      navBarBookmarkList.style.display = "none";
      if (addBookmarkBtn)
         addBookmarkBtn.setAttribute('class', 'ext_navBarButton');
      bookmarksBtn.setAttribute('class', 'ext_navBarButton');
   }
}

function toggleBookmarkList() {

   if (navBarBookmarkList.style.display == "none") {
      navBarBookmark.style.display = "none";
      if (addBookmarkBtn)
         addBookmarkBtn.setAttribute('class', 'ext_navBarButton');
      navBarBookmarkList.style.display = "block";
      bookmarksBtn.setAttribute('class', 'ext_navBarButton ext_buttonActive');
   } else {	
      bookmarksBtn.setAttribute('class', 'ext_navBarButton');
      navBarBookmarkList.style.display = "none";
   }
}

function toggleBookmarkAdd() {

   if (navBarBookmark.style.display == "none") {
      navBarBookmarkList.style.display = "none";
      bookmarksBtn.setAttribute('class', 'ext_navBarButton');
      navBarBookmark.style.display = "block";
      if (addBookmarkBtn)
         addBookmarkBtn.setAttribute('class', 'ext_navBarButton ext_buttonActive');
   } else {	
      if (addBookmarkBtn)
         addBookmarkBtn.setAttribute('class', 'ext_navBarButton');
      navBarBookmark.style.display = "none";
   }
}

// Disable context menu
window.addEventListener("contextmenu", function(e) { e.preventDefault(); })

}
